'                                  /   \
'                          )      ((   ))     (
'( )                      /|\      ))_((     /|\
'|-|                     / | \    (/\|/\)   / | \                      ( )
'| |--------------------/--|-voV---\`|'/--Vov-|--\---------------------|-|
'|-|                         '^`   (o o)  '^`                          | |
'| |   X-GUI 4 source codes 2-1/2  `\Y/'      Kenneth Garin (coder)    |-|
'|-|                                          Joe Bardell (bugs/extra) | |
'| |   Compile EXE using SVGAPV.QLB           Stephen Balkum (svgapv)  |-|
'|-|                                          Daniel Sill (svgapv)     | |
'| |   Syntax- PDS 7.1 (or VBDOS)             HTTP://WWW.XGUI.NET      |-|
'|_|___________________________________________________________________| |
'( )              l   /\ /         ( (       \ /\   l                `\|-|
'                 l /   V           \ \       V   \ l                  ( )
'                 l/                _) )_          \I
'                                   `\ /'
'
DECLARE SUB PANIC (message$)
DECLARE SUB startscript (FileName$, cmd$)
DECLARE SUB setpoi (FileName$, v$)
'$INCLUDE: 'SVGABC.BI'

CONST true = 1, false = 0
DIM SHARED mousepointer$, mousetimer$

SUB chactcol (newcol)
   FK = FREEFILE: KL = false
   OPEN "SETTINGS.INI" FOR INPUT AS FK
   FL = FREEFILE
   OPEN "SETTINGS.TMP" FOR OUTPUT AS FL
   DO UNTIL EOF(FK)
    LINE INPUT #FK, h$
    h$ = UCASE$(LTRIM$(h$))
    IF LEFT$(h$, 13) = "ACTIVE COLOR " THEN
     PRINT #FL, "ACTIVE COLOR" + STR$(newcol): KL = true
     ELSE
     PRINT #FL, h$
    END IF
   LOOP
   IF KL = false THEN PRINT #FL, "ACTIVE COLOR" + STR$(newcol)
   CLOSE FK, FL
   OPEN "SETTINGS.INI" FOR OUTPUT AS FK
   OPEN "SETTINGS.TMP" FOR INPUT AS FL
   DO UNTIL EOF(FL)
    LINE INPUT #FL, h$: PRINT #FK, h$
   LOOP
   CLOSE FK, FL
   KILL "SETTINGS.TMP"
END SUB

SUB chbcolor (newcol)
   FK = FREEFILE: KL = false
   OPEN "SETTINGS.INI" FOR INPUT AS FK
   FL = FREEFILE
   OPEN "SETTINGS.TMP" FOR OUTPUT AS FL
   DO UNTIL EOF(FK)
    LINE INPUT #FK, h$
    h$ = UCASE$(LTRIM$(h$))
    IF LEFT$(h$, 17) = "BACKGROUND COLOR " THEN
     PRINT #FL, "BACKGROUND COLOR" + STR$(newcol): KL = true
     ELSE
     PRINT #FL, h$
    END IF
   LOOP
   IF KL = false THEN PRINT #FL, "BACKGROUND COLOR" + STR$(newcol)
   CLOSE FK, FL
   OPEN "SETTINGS.INI" FOR OUTPUT AS FK
   OPEN "SETTINGS.TMP" FOR INPUT AS FL
   DO UNTIL EOF(FL)
    LINE INPUT #FL, h$: PRINT #FK, h$
   LOOP
   CLOSE FK, FL
   KILL "SETTINGS.TMP"
END SUB

SUB chnonactcol (newcol)
   FK = FREEFILE: KL = false
   OPEN "SETTINGS.INI" FOR INPUT AS FK
   FL = FREEFILE
   OPEN "SETTINGS.TMP" FOR OUTPUT AS FL
   DO UNTIL EOF(FK)
    LINE INPUT #FK, h$
    h$ = UCASE$(LTRIM$(h$))
    IF LEFT$(h$, 13) = "NONACT COLOR " THEN
     PRINT #FL, "NONACT COLOR" + STR$(newcol): KL = true
     ELSE
     PRINT #FL, h$
    END IF
   LOOP
   IF KL = false THEN PRINT #FL, "NONACT COLOR" + STR$(newcol)
   CLOSE FK, FL
   OPEN "SETTINGS.INI" FOR OUTPUT AS FK
   OPEN "SETTINGS.TMP" FOR INPUT AS FL
   DO UNTIL EOF(FL)
    LINE INPUT #FL, h$: PRINT #FK, h$
   LOOP
   CLOSE FK, FL
   KILL "SETTINGS.TMP"
END SUB

SUB chwallpaper (newfile$)
   FK = FREEFILE: KL = false
   OPEN "SETTINGS.INI" FOR INPUT AS FK
   FL = FREEFILE
   OPEN "SETTINGS.TMP" FOR OUTPUT AS FL
   DO UNTIL EOF(FK)
    LINE INPUT #FK, h$
    h$ = UCASE$(LTRIM$(h$))
    IF LEFT$(h$, 10) = "WALLPAPER " THEN
     PRINT #FL, "WALLPAPER " + newfile$: KL = true
     ELSE
     PRINT #FL, h$
    END IF
   LOOP
   IF KL = false THEN PRINT #FL, "WALLPAPER " + newfile$
   CLOSE FK, FL
   OPEN "SETTINGS.INI" FOR OUTPUT AS FK
   OPEN "SETTINGS.TMP" FOR INPUT AS FL
   DO UNTIL EOF(FL)
    LINE INPUT #FL, h$: PRINT #FK, h$
   LOOP
   CLOSE FK, FL
   KILL "SETTINGS.TMP"
END SUB

SUB drw3Dbox (X1%, Y1%, X2%, Y2%, col1%, col2%)
DRWLINE 1, col1%, X1%, Y1%, X2%, Y1%
DRWLINE 1, col1%, X1%, Y1%, X1%, Y2%
DRWLINE 1, col2%, X1% + 1, Y2%, X2%, Y2%
DRWLINE 1, col2%, X2%, Y1% + 1, X2%, Y2%
END SUB

SUB hidegraph (truth%)
IF truth% = false THEN
 a% = PAGEDISPLAY(0, 0, 0)
 ELSE
 h% = XMSSCREENGET%
 a% = PAGEACTIVE%(1)
 e% = XMSSCREENPUT%(h%)
 e% = XMSFREE%(h%)
 a% = PAGEACTIVE%(0)
 a% = PAGEDISPLAY%(0, 0, 1)
END IF
END SUB

SUB PANIC (message$)
tmp% = RESTEXT%: CLS
COLOR 12
PRINT "PANIC: ";
PRINT message$
COLOR 7
SYSTEM
END SUB

SUB scrshot
MOUSESTATUS x%, y%, b%
IF b% = 3 THEN
 MOUSERANGESET x%, y%, x% + 1, y% + 1
 dummy% = PCXMAKE%(0, 0, GETMAXX%, GETMAXY%, "SCRSHOT.PCX")
 MOUSERANGESET 0, 0, GETMAXX%, GETMAXY%
 startscript "MSGBOX.L", "System Message...:Screen shot was saved as SCRSHOT.PCX"
END IF
END SUB

SUB setpoi (FileName$, v$)
  freehandle = FREEFILE
  OPEN FileName$ FOR INPUT AS freehandle
  DO UNTIL EOF(freehandle)
   LINE INPUT #freehandle, tempstr$
   FOR i = 1 TO LEN(tempstr$)
    char$ = MID$(tempstr$, i, 1)
    IF char$ <> "," THEN
     newchar$ = newchar$ + char$
     ELSE
     vv$ = vv$ + CHR$(VAL(newchar$)): newchar$ = ""
    END IF
   NEXT
  LOOP
  CLOSE #freehandle
  v$ = vv$
END SUB

SUB setuppointers (mousefile$, mousefile2$)
IF mousefile$ <> "" THEN
 IF DIR$(mousefile$) <> "" THEN
  setpoi mousefile$, mousepointer$
 END IF
END IF

IF mousefile2$ <> "" THEN
 IF DIR$(mousefile2$) <> "" THEN
  setpoi mousefile2$, mousetimer$
 END IF
END IF
END SUB

SUB startup
IF DIR$("SETTINGS.INI") = "" THEN
 tmp% = RESTEXT%: CLS
 PRINT "Please run SETUP program first"
 SYSTEM
END IF

IF COMMAND$ <> "~+][[]+~" THEN
 PANIC "Don't directly start X-GUI, please use START"
END IF
END SUB

SUB timerset (truth%)
IF truth% = true THEN
 IF mousetimer$ <> "" THEN MOUSECURSORSET mousetimer$
 ELSE
 IF mousepointer$ <> "" THEN MOUSECURSORSET mousepointer$
END IF
END SUB

